import time
import requests
import json

if __name__ == '__main__':

    c3s = [
        {'name': 'Fall 2008', 'forum_id': 256},
        {'name': 'Spring 2009', 'forum_id': 257},
        {'name': 'Fall 2009', 'forum_id': 1346},
        {'name': 'Spring 2010', 'forum_id': 4711},
        {'name': 'Fall 2010', 'forum_id': 2101},
        {'name': 'Spring 2011', 'forum_id': 20110},
        {'name': 'Spring 2012', 'forum_id': 2012},
        {'name': 'Summer 2013', 'forum_id': 18},
        {'name': 'Summer 2014', 'forum_id': 8888},
        {'name': 'Winter 2014', 'forum_id': 6843},
        {'name': 'Summer 2015', 'forum_id': 89},
        {'name': 'Winter 2016', 'forum_id': 777},
        {'name': 'Summer 2016', 'forum_id': 20162},
        {'name': 'Winter 2017', 'forum_id': 20171},
        {'name': 'Summer 2017', 'forum_id': 9998},
        {'name': 'Winter 2018', 'forum_id': 2018},
        {'name': 'Summer 2018', 'forum_id': 20182},
        {'name': 'Winter 2019', 'forum_id': 2019},
        {'name': 'Summer 2019', 'forum_id': 20192},
        {'name': 'Winter 2020', 'forum_id': 2020},
        {'name': 'Summer 2020', 'forum_id': 20202},
        {'name': 'Winter 2021', 'forum_id': 2021},
        {'name': 'Summer 2021', 'forum_id': 20212},
        {'name': 'Winter 2022', 'forum_id': 2022},
        {'name': 'Summer 2022', 'forum_id': 20222},
        {'name': 'Winter 2023', 'forum_id': 2023},
        {'name': 'Summer 2023', 'forum_id': 20232},
        {'name': 'Winter 2024', 'forum_id': 2024}
    ]

    for c3 in c3s:
        print(c3['name'])

        threads = []
        num_stickies = 0

        url = f'https://www.smwcentral.net/ajax.php?a=getforum&id={c3["forum_id"]}'
        response = requests.get(url)
        if response.status_code != 200:
            print('something went wrong')
            exit(-1)

        # slightly rename/restructure the data to fit the format that stats.py expects
        # (originally I was parsing the site's HTML, but now there's an official API
        # which returns *almost* the same format as the one I thought up,
        # and I can't be bothered to rewrite the whole code, so I'm just making it fit my old format)
        forum_data = json.loads(response.text)
        for t in forum_data['threads']:

            if t['importance'] != 0:
                num_stickies += 1
                continue

            threads.append({
                'id': t['id'],
                'name': t['title'],
                'authors': [
                    {'id': t['author']['id'], 'name': t['author']['username']}
                ]
            })

        print(f'    {len(threads)} threads ({len(threads) + num_stickies} including stickies)')
        c3['threads'] = threads

        time.sleep(60)

    c3s_json = json.dumps(c3s)
    with open('c3s.json', 'w', encoding='utf-8') as f:
        f.write(c3s_json)

    print(c3s)
